#
# hello.SPU0414HR5H.py
#
# plot SPU0414HR5H microphone audio
#    hello.SPU0414HR5H.py serial_port
#
# Neil Gershenfeld 11/17/15
# (c) Massachusetts Institute of Technology 2015
#
# This work may be reproduced, modified, distributed,
# performed, and displayed for any purpose. Copyright is
# retained and must be preserved. The work is provided
# as is; no warranty is provided, and users accept all 
# liability.
#	*1 modified by Jimena Gálvez 2021

from tkinter import *								
import serial

NX = 500 									#*1   width of the window
NY = 500									#*1   height of the window
nloop = 100									# variables for the line
path = []
baseline = 0
baseline_filt = 0.01
gain = 5

def idle(parent,canvas):
   global path, baseline
   #
   # idle routine
   #
   # look for framing
   #
   byte2 = 0
   byte3 = 0
   byte4 = 0
   while 1:
      byte1 = byte2
      byte2 = byte3
      byte3 = byte4
      byte4 = ord(ser.read())
      if ((byte1 == 1) & (byte2 == 2) & (byte3 == 3) & (byte4 == 4)):
         break
   path = []
   for i in range(nloop):						# this part of the code creates the "wave" 
      lo = ord(ser.read())
      hi = ord(ser.read())
      reading = 256*hi + lo
      baseline = baseline_filt*reading + (1-baseline_filt)*baseline
      value = NY/2 + gain*(reading - baseline)
      path.append(i*NY/float(nloop))
      path.append(value)
   canvas.delete("path")
   canvas.create_line(path,tag="path",width=5,fill="#ffb31c")	# line (wave) properties #+1 changed width 5px + color
   parent.after_idle(idle,parent,canvas)

#
# open serial port
#
ser = serial.Serial('/dev/ttyUSB0',9600)				#*1 port namechanged e.g. '/dev/ttyUSB0' on Linux or 'COM3' on Windows
#
# start plotting
#
root = Tk()								# Initialize window, call constructor *1 changed library element
root.title('hello.jimenas.mems.mic')					#*1 changed title of the window
root.bind('<Escape>', 'exit')						#*1 handling1event: bind escape button to close GUI
canvas = Canvas(root, width=NX, height=NY, background='gray75')	# size of the window #*1 changed background
canvas.pack()								# function pack organizes the canvas
root.after(100,idle,root,canvas)					# function after 100 miliseconds
root.mainloop()							#*1 Main loop. GUI doesn't disappear right away.
